=== examples/python/xds/requirements.txt ===
grpcio>=1.28.1
protobuf
grpcio-reflection
grpcio-health-checking
