=== debian/changelog ===
grpc (1.30.2-3) unstable; urgency=medium

  * Backport upstream fixes for:
    - member variable should not be a reference; causing crash when used in
      destructor,
    - fixing a member var to not be a reference.
  * Add upstream metadata.
  * Update packaging bits.
  * Update watch file.
  * Update debhelper level to 13 .
  * Update Standards-Version to 4.5.1 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 04 Feb 2021 10:44:30 +0100

grpc (1.30.2-2.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Debian Janitor ]
  * Apply multi-arch hints.
    + ruby-grpc: Add Multi-Arch: same.

  [ Andreas Henriksson ]
  * Mark protobuf-compiler-grpc Multi-Arch: foreign.
    Thanks to Helmut for valuable insight and review. (Closes: #976651)
  * Cherry-pick python grpcio 'is not' fix from upstream.
    This fixes a FTBFS with python3.9 (current default in bullseye).

 -- Andreas Henriksson <andreas@fatal.se>  Wed, 13 Jan 2021 22:53:15 +0100

grpc (1.30.2-2) unstable; urgency=medium

  * Add Break and Replaces on libgrpc9 to libgrpc10 (closes: #966116).
  * Upload to Sid (closes: #963583).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 24 Jul 2020 17:28:01 +0200

grpc (1.30.2-1) experimental; urgency=medium

  * New upstream release.
  * Update patches.

  [ Praveen Arimbrathodiyil ]
  * Bump minimum version of gem2deb to 1.0~ .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 18 Jul 2020 08:53:56 +0200

grpc (1.30.1-1) experimental; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 13 Jul 2020 20:59:22 +0200

grpc (1.30.0-1) experimental; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 26 Jun 2020 12:24:41 +0200

grpc (1.30.0~pre1-1) experimental; urgency=medium

  * New major upstream pre-release version.
  * Update patches.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 12 Jun 2020 13:11:11 +0200

grpc (1.29.1-1) experimental; urgency=medium

  * New upstream release:
    - fixes endless looping with default settings (closes: #959675).
  * Update patches.
  * Library transition from libgrpc9 to libgrpc10 .

  [ Adrian Bunk <bunk@debian.org> ]
  * Link with libatomic on armel, mips, mipsel and powerpc (closes: #961193).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 24 May 2020 18:35:05 +0000
